(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('systelab-preferences', ['exports', '@angular/core'], factory) :
    (global = global || self, factory(global['systelab-preferences'] = {}, global.ng.core));
}(this, (function (exports, core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var StorageService = /** @class */ (function () {
        function StorageService(storage) {
            this.storage = storage;
            this.prefix = 'Systelab';
        }
        StorageService.prototype.usePrefix = function (prefix) {
            this.prefix = prefix;
        };
        StorageService.prototype.clear = function () {
            this.storage.clear();
        };
        StorageService.prototype.put = function (key, value) {
            this.storage.setItem(this.prefix + '.' + key, JSON.stringify(value));
        };
        StorageService.prototype.get = function (key, defaultValue) {
            var value = this.parse(this.storage.getItem(this.prefix + '.' + key) || 'null') || null;
            return value ? value : defaultValue;
        };
        StorageService.prototype.remove = function (key) {
            this.storage.removeItem(this.prefix + '.' + key);
        };
        StorageService.prototype.removeStartsWith = function (startWith) {
            for (var i = this.storage.length - 1; i >= 0; i--) {
                if (this.storage.key(i).startsWith(this.prefix + '.' + startWith)) {
                    this.storage.removeItem(this.storage.key(i));
                }
            }
        };
        StorageService.prototype.removeEndsWith = function (endsWith) {
            for (var i = this.storage.length - 1; i >= 0; i--) {
                if (this.storage.key(i).endsWith(endsWith)) {
                    this.storage.removeItem(this.storage.key(i));
                }
            }
        };
        StorageService.prototype.parse = function (text) {
            try {
                return JSON.parse(text) || null;
            }
            catch (e) {
                return text;
            }
        };
        return StorageService;
    }());

    var LocalStorageService = /** @class */ (function (_super) {
        __extends(LocalStorageService, _super);
        function LocalStorageService() {
            return _super.call(this, localStorage) || this;
        }
        LocalStorageService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function LocalStorageService_Factory() { return new LocalStorageService(); }, token: LocalStorageService, providedIn: "root" });
        LocalStorageService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], LocalStorageService);
        return LocalStorageService;
    }(StorageService));

    var compressor = pako;
    var MemoryStorageService = /** @class */ (function () {
        function MemoryStorageService() {
            this.preferences = new Map();
        }
        MemoryStorageService.prototype.clear = function () {
            this.preferences.clear();
        };
        MemoryStorageService.prototype.put = function (key, value) {
            this.preferences.set(key, value);
        };
        MemoryStorageService.prototype.get = function (key, defaultValue) {
            var value = this.preferences.get(key);
            if (value === undefined || value === null) {
                if (defaultValue === undefined || defaultValue === null) {
                    return value;
                }
                else {
                    return defaultValue;
                }
            }
            else {
                return value;
            }
        };
        MemoryStorageService.prototype.remove = function (key) {
            this.preferences.delete(key);
        };
        MemoryStorageService.prototype.removeStartsWith = function (startWith) {
            var _this = this;
            this.preferences.forEach(function (value, key) {
                if (key.startsWith(startWith)) {
                    _this.remove(key);
                }
            });
        };
        MemoryStorageService.prototype.removeEndsWith = function (endsWith) {
            var _this = this;
            this.preferences.forEach(function (value, key) {
                if (key.endsWith(endsWith)) {
                    _this.remove(key);
                }
            });
        };
        MemoryStorageService.prototype.getInCompressFormat = function () {
            var passToServer = {};
            this.preferences.forEach(function (value, key) {
                passToServer[key] = value;
            });
            var binaryString = compressor.deflate(JSON.stringify(passToServer), { to: 'string' });
            return btoa(binaryString);
        };
        MemoryStorageService.prototype.getInStringFormat = function () {
            var passToServer = {};
            this.preferences.forEach(function (value, key) { return passToServer[key] = value; });
            return JSON.stringify(passToServer);
        };
        MemoryStorageService.prototype.putFromCompressFormat = function (compressed) {
            var _this = this;
            this.clear();
            // Do your best
            try {
                var result = compressor.inflate(atob(compressed), { to: 'string' });
                var parsed_1 = JSON.parse(result);
                Object.keys(parsed_1)
                    .forEach(function (key) { return _this.preferences.set(key, parsed_1[key]); });
            }
            catch (ex) {
            }
        };
        MemoryStorageService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function MemoryStorageService_Factory() { return new MemoryStorageService(); }, token: MemoryStorageService, providedIn: "root" });
        MemoryStorageService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], MemoryStorageService);
        return MemoryStorageService;
    }());

    var SessionStorageService = /** @class */ (function (_super) {
        __extends(SessionStorageService, _super);
        function SessionStorageService() {
            return _super.call(this, sessionStorage) || this;
        }
        SessionStorageService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function SessionStorageService_Factory() { return new SessionStorageService(); }, token: SessionStorageService, providedIn: "root" });
        SessionStorageService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], SessionStorageService);
        return SessionStorageService;
    }(StorageService));


    (function (StorageType) {
        StorageType[StorageType["IN_MEMORY_STORAGE"] = 1] = "IN_MEMORY_STORAGE";
        StorageType[StorageType["LOCAL_STORAGE"] = 2] = "LOCAL_STORAGE";
        StorageType[StorageType["SESSION_STORAGE"] = 3] = "SESSION_STORAGE";
    })(exports.StorageType || (exports.StorageType = {}));
    var PreferencesService = /** @class */ (function () {
        function PreferencesService(memoryService, localService, sessionService) {
            this.memoryService = memoryService;
            this.localService = localService;
            this.sessionService = sessionService;
            this.storage = exports.StorageType.IN_MEMORY_STORAGE;
        }
        PreferencesService.prototype.setStorage = function (storage) {
            this.storage = storage;
        };
        PreferencesService.prototype.getStorage = function () {
            return this.storage;
        };
        PreferencesService.prototype.usePrefix = function (prefix) {
            if (this.storage === exports.StorageType.LOCAL_STORAGE) {
                this.localService.usePrefix(prefix);
            }
            else if (this.storage === exports.StorageType.SESSION_STORAGE) {
                this.sessionService.usePrefix(prefix);
            }
            else {
                console.error('You can not set a prefix for In-memory preferences');
            }
        };
        PreferencesService.prototype.clear = function () {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                this.memoryService.clear();
            }
            else if (this.storage === exports.StorageType.LOCAL_STORAGE) {
                this.localService.clear();
            }
            else {
                this.sessionService.clear();
            }
        };
        PreferencesService.prototype.put = function (key, value) {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                this.memoryService.put(key, value);
            }
            else if (this.storage === exports.StorageType.LOCAL_STORAGE) {
                this.localService.put(key, value);
            }
            else {
                this.sessionService.put(key, value);
            }
        };
        PreferencesService.prototype.get = function (key, defaultValue) {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                return this.memoryService.get(key, defaultValue);
            }
            else if (this.storage === exports.StorageType.LOCAL_STORAGE) {
                return this.localService.get(key, defaultValue);
            }
            else {
                return this.sessionService.get(key, defaultValue);
            }
        };
        PreferencesService.prototype.remove = function (key) {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                this.memoryService.remove(key);
            }
            else if (this.storage === exports.StorageType.LOCAL_STORAGE) {
                this.localService.remove(key);
            }
            else {
                this.sessionService.remove(key);
            }
        };
        PreferencesService.prototype.removeStartsWith = function (startWith) {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                this.memoryService.removeStartsWith(startWith);
            }
            else if (this.storage === exports.StorageType.LOCAL_STORAGE) {
                this.localService.removeStartsWith(startWith);
            }
            else {
                this.sessionService.removeStartsWith(startWith);
            }
        };
        PreferencesService.prototype.removeEndsWith = function (endsWith) {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                this.memoryService.removeEndsWith(endsWith);
            }
            else if (this.storage === exports.StorageType.LOCAL_STORAGE) {
                this.localService.removeEndsWith(endsWith);
            }
            else {
                this.sessionService.removeEndsWith(endsWith);
            }
        };
        PreferencesService.prototype.getInStringFormat = function () {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                return this.memoryService.getInStringFormat();
            }
            else {
                return '';
            }
        };
        PreferencesService.prototype.getInCompressFormat = function () {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                return this.memoryService.getInCompressFormat();
            }
            else {
                return '';
            }
        };
        PreferencesService.prototype.putFromCompressFormat = function (compressed) {
            if (this.storage === exports.StorageType.IN_MEMORY_STORAGE) {
                this.memoryService.putFromCompressFormat(compressed);
            }
        };
        PreferencesService.ctorParameters = function () { return [
            { type: MemoryStorageService },
            { type: LocalStorageService },
            { type: SessionStorageService }
        ]; };
        PreferencesService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function PreferencesService_Factory() { return new PreferencesService(core["ɵɵinject"](MemoryStorageService), core["ɵɵinject"](LocalStorageService), core["ɵɵinject"](SessionStorageService)); }, token: PreferencesService, providedIn: "root" });
        PreferencesService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], PreferencesService);
        return PreferencesService;
    }());

    var SystelabPreferencesModule = /** @class */ (function () {
        function SystelabPreferencesModule() {
        }
        SystelabPreferencesModule = __decorate([
            core.NgModule({})
        ], SystelabPreferencesModule);
        return SystelabPreferencesModule;
    }());

    exports.LocalStorageService = LocalStorageService;
    exports.MemoryStorageService = MemoryStorageService;
    exports.PreferencesService = PreferencesService;
    exports.SessionStorageService = SessionStorageService;
    exports.SystelabPreferencesModule = SystelabPreferencesModule;
    exports.ɵa = StorageService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=systelab-preferences.umd.js.map
